----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:21:23 09/17/2015 
-- Design Name: 
-- Module Name:    Top_Count - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;


-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Top_Count is
    Port ( clock : in STD_LOGIC;
			  reset : in  STD_LOGIC;
           load : in  STD_LOGIC;
           up : in  STD_LOGIC;
           down : in  STD_LOGIC;
           load_val : in  STD_LOGIC_VECTOR (3 downto 0);
           count_out : out  STD_LOGIC_VECTOR (7 downto 0));
end Top_Count;

architecture Behavioral of Top_Count is


--Component declaration
	COMPONENT debouce
	PORT(
		clock : IN std_logic;
		reset : IN std_logic;
		D_IN : IN std_logic;          
		D_OUT : OUT std_logic
		);
	END COMPONENT;

	COMPONENT pulse_gen
	PORT(
		clock : IN std_logic;
		reset : IN std_logic;
		d_in : IN std_logic;          
		d_out : OUT std_logic
		);
	END COMPONENT;

	COMPONENT clock_divider
	PORT(
		clock : IN std_logic;          
		clk_out : OUT std_logic
		);
	END COMPONENT;	
	
		COMPONENT up_down_counter
	PORT(
		clk_div : IN std_logic;
		reset : IN std_logic;
		load_ce : IN std_logic;
		up_ce : IN std_logic;
		down_ce : IN std_logic;
		load_val : IN std_logic_vector(3 downto 0);          
		count_out : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;
	
-- Signal declaration
signal d_load : std_logic;
signal d_up : std_logic;
signal d_down : std_logic;
signal up_ce : std_logic;
signal down_ce : std_logic;
signal load_ce : std_logic;
signal clk_div : std_logic;

begin

	freq_divider: clock_divider PORT MAP(
		clock => clock,
		clk_out => clk_div
	);


load_debouce: debouce PORT MAP(
		clock => clk_div,
		reset => reset,
		D_IN => load,
		D_OUT => d_load 
	);



up_debouce: debouce PORT MAP(
		clock => clk_div,
		reset => reset,
		D_IN => up,
		D_OUT => d_up 
	);


down_debouce: debouce PORT MAP(
		clock => clk_div,
		reset => reset,
		D_IN => down,
		D_OUT => d_down 
	);


	up_pulse: pulse_gen PORT MAP(
		clock => clk_div,
		reset => reset,
		d_in => d_up,
		d_out => up_ce
	);

	down_pulse: pulse_gen PORT MAP(
		clock => clk_div,
		reset => reset,
		d_in => d_down,
		d_out => down_ce
	);
	
	load_pulse: pulse_gen PORT MAP(
		clock => clk_div,
		reset => reset,
		d_in => d_load,
		d_out => load_ce
	);
	
	counter: up_down_counter PORT MAP(
		clk_div => clk_div,
		reset => reset,
		load_ce => load_ce,
		up_ce => up_ce,
		down_ce => down_ce,
		load_val => load_val,
		count_out => count_out
	);

	
	end Behavioral;

