----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:33:46 10/21/2015 
-- Design Name: 
-- Module Name:    up_down_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity up_down_counter is
Port ( clk_div : in STD_LOGIC;
			  reset : in  STD_LOGIC;
           load_ce : in  STD_LOGIC;
           up_ce : in  STD_LOGIC;
           down_ce : in  STD_LOGIC;
           load_val : in  STD_LOGIC_VECTOR (3 downto 0);
           count_out : out  STD_LOGIC_VECTOR (7 downto 0));

end up_down_counter;

architecture Behavioral of up_down_counter is

signal count : std_logic_vector(7 downto 0);

begin

	counter: process (clk_div,load_ce,load_val,down_ce,up_ce, reset) 
	begin
	if reset = '1' then 
		count <= (others => '0');
	elsif rising_edge(clk_div) then
			if up_ce = '1' then   
				count <= count + 1;
			elsif down_ce = '1' then
				count <= count - 1;
			elsif load_ce='1' then
				count <= "0000" & load_val;
			end if;
	 end if;
	end process;
	
		count_out <= count;
		
end Behavioral;

